local Module = UnderHood:GetModule("Bars")

local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local unpack = unpack

local _, unitClass = UnitClass("player")

local Provider = UnderHood.OO:NewClass("HarmonyBarProvider", "BarProvider")

function Provider:init(factory)
	super(self, factory, "AceTimer-3.0")
end

function Provider:OnAcquire(bar, zone, settings)
	super(self, bar, zone, settings)

	if unitClass == "MONK" then
		self:RegisterEvent("UNIT_DISPLAYPOWER");
		self:RegisterUnitEvent("UNIT_POWER_FREQUENT", "player", "vehicle");
		self:UpdateColor()
	end
end

function Provider:UpdateColor()
	local r, g, b = unpack(Module.db.profile.colors.power.harmony)

	self:SetColor(r, g, b, 1)
end

function Provider:UpdateValue()
	super(self)

	local current, max = UnitPower("player", SPELL_POWER_LIGHT_FORCE), UnitPowerMax("player", SPELL_POWER_LIGHT_FORCE)

	current = (max > 0) and (current / max) or 0

	self:SetValue(current)
end

local Factory = UnderHood.OO:NewClass("HarmonyBarProviderFactory", "BarProviderFactory")

function Factory:init()
	local L = Module.L

	super(self, "Harmony", L["Harmony"])
end

function Factory:CreateProvider()
	return Provider:new(self)
end

local factory = Factory:new()

Module:RegisterProviderFactory(factory:GetName(), factory)
